﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Lab1.Entities;

namespace Lab1.Drawnings;

/// <summary>
/// Класс, отвечающий за прорисовку и перемещение объекта-сущности
/// </summary>
public class DrawningRoadTrain : DrawningTruck
{
    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="flashingLights">Признак наличия мигалок</param>
    /// <param name="ladle">Признак наличия ковша</param>

    public DrawningRoadTrain(int speed, int weight, Color bodyColor, Color additionalColor, bool flashingLights, bool ladle) : base(140, 70)
    {
        EntityTruck = new EntityRoadTrain(speed, weight, bodyColor, additionalColor, flashingLights, ladle);

    }

    /// <summary>
    /// переопределение метода DrawTransport
    /// </summary>
    public override void DrawTransport(Graphics g) 
    {
        if (EntityTruck == null || EntityTruck is not EntityRoadTrain roadTrain || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }

        Brush additionalBrush = new SolidBrush(roadTrain.AdditionalColor);
        Pen additionalPen = new(roadTrain.AdditionalColor);
        // баки
        if (roadTrain.Ladle)
        {
            g.FillEllipse(additionalBrush, _startPosX.Value + 10, _startPosY.Value, 105, 32);
        }
        // щетка
        if (roadTrain.FlashingLights)
        {
            g.DrawLine(additionalPen, _startPosX.Value + 80, _startPosY.Value + 50, _startPosX.Value + 80, _startPosY.Value + 75);
            g.DrawLine(additionalPen, _startPosX.Value + 80, _startPosY.Value + 50, _startPosX.Value + 90, _startPosY.Value + 75);
            g.DrawLine(additionalPen, _startPosX.Value + 80, _startPosY.Value + 50, _startPosX.Value + 100, _startPosY.Value + 75);
            g.DrawLine(additionalPen, _startPosX.Value + 80, _startPosY.Value + 50, _startPosX.Value + 110, _startPosY.Value + 75);
            g.DrawLine(additionalPen, _startPosX.Value + 80, _startPosY.Value + 50, _startPosX.Value + 120, _startPosY.Value + 75);
        }

        base.DrawTransport(g);
    }

}
