﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Lab1.MovementStrategy;

public class MoveToBorder : AbstractStrategy
{
    /// <summary>
    /// Переопределение метода IsTargetDestinaion
    /// </summary>
    protected override bool IsTargetDestinaion()
    {
        var objectparams = GetObjectParameters;
        if (objectparams != null)
        {
            return objectparams.RightBorder <= FieldWidth &&
            objectparams.RightBorder + GetStep() >= FieldWidth &&
            objectparams.DownBorder <= FieldHeight &&
            objectparams.DownBorder + GetStep() >= FieldHeight;
        }
        return false;
    }

    /// <summary>
    /// Переопределение метода MoveToTarget
    /// </summary>
    protected override void MoveToTarget()
    {
        var objectparams = GetObjectParameters;
        if (objectparams == null)
        {
            return;
        }
        var dX = objectparams.RightBorder - FieldWidth;
        if (Math.Abs(dX) > GetStep())
        {
            if (dX > 0)
            {
                MoveLeft();
            }
            else
            {
                MoveRight();
            }
        }
        var dY = objectparams.DownBorder - FieldHeight;
        if (Math.Abs(dY) > GetStep())
        {
            if (dY > 0)
            {
                MoveUp();
            }
            else
            {
                MoveDown();
            }
        }
    }
}
